package Objects;

import java.awt.Graphics;
import java.awt.Image;
import javax.imageio.ImageIO;



import Game.InputHandler;

public class Ball extends GameplayObjects{

	/*
	 * WICHTIG*********************************************************
	 * SPTER FR DIE BLLE ZWEI KLASSEN VERWENDEN
	 * AUS ZEITGRNDEN WIRD ZUNCHST EINE VERWENDET
	 * DAHER MSSEN COM UND PLAYER POSITION IN
	 * DER UPDATE METHODE BERGEBEN WERDEN
	 * IS BLD, NDER ICH SPTER
	 */
	
	private String type;
	private boolean playerHook = false, comHook = false;
	
	public Ball(Image[] ballImages, int startX, int startY)
	{
		//ZufallsBall
		double random = Math.random();
		
		if(random <= 0.2) this.type = "RED";
		if(random > 0.2 && random <= 0.4) this.type = "GREEN";
		if(random > 0.4 && random <= 0.6) this.type = "YELLOW";
		if(random > 0.6 && random <= 0.8) this.type = "BLUE";
		if(random > 0.8 && random <= 1.0) this.type = "PURPLE";
		
		try
		{
			//Spter zur Performanceoptimierung in den Konstruktor ein Array von Images bergeben die mit dem Level
			// geladen werden. momentan ld der Ball seine Grafik selbst von der HDD wenn er konstruiert wird.
			switch(this.type)
			{
			case "RED":
				this.img = ballImages[0];
				break;
			case "GREEN":
				this.img = ballImages[1];
				break;
			case "YELLOW":
				this.img = ballImages[2];
				break;
			case "BLUE":
				this.img = ballImages[3];
				break;
			case "PURPLE":
				this.img = ballImages[4];
				break;
			}
		}
		catch(Exception e)
		{
			System.out.println("Ballgrafik fehlerhaft!");
			e.printStackTrace();
			System.exit(0);
		}
		//Position an Generator
		this.posX = startX;
		this.posY = startY;
		this.hotX = this.posX + this.img.getWidth(null)/2;
		this.hotY = this.posY + this.img.getHeight(null)/2;
	}
	
	public void update(InputHandler input, int playerHotX, int playerHotY, int comHotX, int comHotY) {
		
		if(playerHook)
		{
			this.posX = playerHotX - this.img.getWidth(null)/2;
			this.posY = playerHotY- 2 - this.img.getHeight(null)/2;;
			this.hotX = this.posX + this.img.getWidth(null)/2;
			this.hotY = this.posY + this.img.getHeight(null)/2;
		}
		if(comHook)
		{
			this.posX = comHotX - this.img.getWidth(null)/2;
			this.posY = comHotY- 2 - this.img.getHeight(null)/2;;
			this.hotX = this.posX + this.img.getWidth(null)/2;
			this.hotY = this.posY + this.img.getHeight(null)/2;
		}
	}

	@Override
	public void render(Graphics g) {
		g.drawImage(img, posX, posY,null);
	}

	@Override
	public void move(int addX, int addY) {
		this.oldPosX = posX;
		this.oldPosY = posY;
		
		this.posX = this.posX + addX;
		this.posY = this.posY + addY;
		this.hotX = this.posX + this.img.getWidth(null)/2;
		this.hotY = this.posY + this.img.getHeight(null)/2;
	}

	@Override
	public void update(InputHandler input) {
		//Muss hier nochwas rein?
		
	}
	public void togglePlayerHook()
	{
		playerHook = true;
	}
	public void toggleComHook()
	{
		comHook = true;
	}
	public String getType()
	{
		return this.type;
	}

	@Override
	public int getPosX() {
		return this.posX;
	}

	@Override
	public int getPosY() {
		return this.posY;
	}

	@Override
	public int getHotSpotY() {
		return this.hotY;
	}

	@Override
	public int getHotSpotX() {
		return this.hotX;
	}
}
