package Game;

import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.JFrame;
import javax.swing.JPanel;

@SuppressWarnings("serial")
public class Window extends JFrame{

	//Var
	private int windowWidth = 640, windowHeight = 640;
	public Insets insets;
	private JPanel canvas;
		
	public Window()
	{
		super();
		setTitle("BallsDeep 0.5.1"); 
		setSize(windowWidth, windowHeight); 
		this.setLocation(300,100);
		insets = this.getInsets();
		setResizable(false); 
		setDefaultCloseOperation(EXIT_ON_CLOSE); 
		canvas = new JPanel();
		this.add(canvas,BorderLayout.CENTER);
 
		setVisible(true); 
	}
	
	public Graphics getCanvasGraphics()
	{
		return canvas.getGraphics();
	}
	
}
