package Objects;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.geom.AffineTransform;

import Game.InputHandler;

public abstract class GameplayObjects {
	//VAR
		protected Image img;
		protected int posX, posY, oldPosX, oldPosY;
		protected  int speed, height, width;
		protected int hotX, hotY;

		//Methoden
		public abstract void update(InputHandler input);
		public abstract void render(Graphics g);
		
		public abstract void move(int addX, int addY);
		
		public abstract int getPosX();
		public abstract int getPosY();
		public abstract int getHotSpotY();
		public abstract int getHotSpotX();
}
