package Objects;

import java.awt.Graphics;
import java.awt.Image;

import Game.InputHandler;

public class MenuBall extends Ball{
	private int dirX = 1, dirY = 1;
	//Adaptierte ASTEROIDEN aus meinem SkyDiver
	public MenuBall(Image[] ballImages)
	{
		super(ballImages, (int)(Math.random()*640), (int)(Math.random()*640));
		
		this.speed =(int)( Math.random()*3)+1;
		
		
		
		double randomDir = Math.random();
		if(randomDir <=0.3) dirX = -1;dirY = -1;
		if(randomDir >0.3 && randomDir <= 0.6) dirX = -1;dirY = -1;
		if(randomDir >0.6) dirX = 1; dirY = -1;
		
		
		
	}
	
	@Override
	public void update(InputHandler input) {

		//Richtungsnderung wenn zu weit aus der Frame
		if(this.posX >= 700)
		{
			this.dirX = -1;
		}
		if(this.posX <= -100)
		{
			this.dirX = 1;
		}
		if(this.posY >= 700)
		{
			this.dirY = -1;
		}
		if(this.posY <= -100)
		{
			this.dirY = 1;
		}
		move(this.speed*this.dirX,this.speed*this.dirY);
		
	}

	@Override
	public void render(Graphics g) {
		g.drawImage(img, this.posX, this.posY,null);
	}


}
